<?php
class tUser {
  var $id;                       // id uivatele
  var $aid;                      // identifikan etzec
  var $sql;                      // objekt tMySql pro komunikaci s databz
  var $tb_user;                  // nzev tabulky s uivately
  var $field_login='login';      // nzev pole s loginem
  var $field_password='password';// nzev pole s heslem
  var $field_auth='auth';        // nzev pole identifikanm etzcem
  var $field_id='id';            // nzev pole id uivatele
  var $url_aid;                  // obsahuje identifikan etzec pokud nen pedvn v cookie
  var $curl_aid;                 // obsahuje & nazen url promnn, = a identifikan etzec pokud nen pedvn v cookie
  var $use_cookie = true;        // pokud je nastaveno na TRUE pokus se pedvat identifikan etzec v cookie
  var $cookie_name = 'aid';      // nzev cookie s identifikanm etzcem
  var $url_name = 'aid';         // nzev promnn v url s identifikanm etzcem

  // Tato funkce pihls uivatele
  function login($login, $password) {
    // pokus se najt uivatele podle loginu a hesla
    $this->id = $this->sql->query_result(
     'SELECT '.$this->field_id.' FROM '.$this->tb_user.'
      WHERE '.$this->field_login.'="'.addslashes($login).'"
      AND '.$this->field_password.'="'.addslashes($password).'"');
    if($this->id) {
      // pokud je heslo a login spravne vytvo identifikan etzec
      $auth = md5($login.$password.microtime());
      $this->sql->query('',
        'UPDATE '.$this->tb_user.'
         SET '.$this->field_auth.'="'.addslashes($auth).'"
         WHERE '.$this->field_id.'='.$this->id);
      $this->aid = $auth.'x'.$this->id;
      $this->url_aid = $this->aid;
      $this->curl_aid = '&amp;'.$this->url_name.'='.$this->url_aid;
      return(true);
    } else
      return(false);
  }
  
  // odhls uivatele
  function logout() {
    // odhls uivatele tak e smae identifikan etzec v db
    $this->sql->query('',
      'UPDATE '.$this->tb_user.'
       SET '.$this->field_auth.'=""
       WHERE '.$this->field_id.'='.$this->id);
    // aby se nepedval neplatn identifikan etzec odstran jej
    $this->id=0;
    $this->aid='';
    $this->url_aid='';
    $this->curl_aid='';
    // pokud se pouv cookie smae ji
    if ($this->use_cookie) setCookie($this->cookie_name, '');
  }
  
  // ov uivatele
  function check($aid = '') {
    // pokud nebyl identifikan etzec zadn pokus se jej zskat ze $_REQUEST nebo $_COOKIE
    if (!$aid) {
      $aid = $_REQUEST[$this->url_name];
      if (!$aid) $aid = $_COOKIE[$this->cookie_name];
    };
    // oddl id uivatele a hash
    list($auth, $id) = explode('x', $aid);
    $id = (int)$id;
    // pokud nen id nebo hash przdn ov pihlen uivatele v db
    if ($auth and $id) {
      $this->id = $this->sql->query_result(
       'SELECT id FROM '.$this->tb_user.'
        WHERE '.$this->field_id.'='.$id.'
        AND '.$this->field_auth.'="'.addslashes($auth).'"');
      if($this->id) {
        // pokud oven probhlo spn nastav identifikan etzec
        $this->aid = $auth.'x'.$this->id;
        // nastav cookie
        if ($this->use_cookie)
          setCookie($this->cookie_name, $this->aid);
        // pokud se stejn hodnota jako v url nepedala tak v cookie, znamen to e cookie nepracujou spvn a poteba pedvat identifikan etzec v url
        if ($_REQUEST[$this->url_name] != $_COOKIE[$this->cookie_name]) {
          $this->url_aid = $this->aid;
          $this->curl_aid = '&amp;'.$this->url_name.'='.$this->url_aid;
        };
        return(true);
      } else
        return(false);
    } else 
      return(false);
  }
  // pid novho uivatele
  function register($data) {
    // nejprve ov jestli uivatel s poadovanm login jet neexistuje
    if (!$this->sql->query_result(
       'SELECT COUNT(*) FROM '.$this->tb_user.'
        WHERE '.$this->field_login.'="'.addslashes($data[$this->field_login]).'"')) {
      // pokud login jet neexistuje vlo daje do db a pihls uivatele
      $this->sql->insert($this->tb_user, $data);
      $this->login($data[$this->field_login], $data[$this->field_password]);
      return(true);
    } else {
      return(false);
    };
  }
  // te informace o uivateli
  function getInfo($cols = '*') {
    if ($this->id) {
      return($this->sql->query_fetch_assoc(
       'SELECT '.$cols.'
        FROM '.$this->tb_user.'
        WHERE '.$this->field_id.'='.$this->id));
    } else
      return(false);
  }
  // uprav informace o uivateli v db
  function update($data) {
    if ($this->id) {
      $this->sql->update($data, $this->field_id.'='.$this->id);
      return(true);
    } else
      return(false);
  }
}

?>
